<?php
/**
 * N-System Slideshow
 * @author Norman "Spawnie" Malessa
 * @license GPLv3 http://www.gnu.org/licenses/gpl.html
 * @email info@n-system.de
 * @url http://www.n-system.de/
 */

defined('_JEXEC') or die('Restricted access');


/**
 * scales images into the given <div> size
 * @param int sourceW
 * @param int sourceH
 * @param int targetW
 * @param int targetH
 * @return array
 */
function scaleImage($sourceW, $sourceH, $targetW, $targetH) {
	$aSize = array(
		'w' => $sourceW,
		'h' => $sourceH
	);
	if ($sourceW > $targetW || $sourceH > $targetH) {
		$scalew = $sourceW / $targetW;
        $scaleh = $sourceH / $targetH;
        
        // Skalierung
        $scale = $scalew;
        if ($scalew < $scaleh) {
                $scale = $scaleh;
        }
        $aSize = array(
        	'w' => $sourceW/$scale,
        	'h' => $sourceH/$scale
        );
		
	}
	
	return $aSize;
}


// Parameter
$slideFolder	= 'images/' . $params->get('slide_folder');
$slideDuration	= intval($params->get('slide_duration'));
$slideTime		= intval($params->get('slide_time'));
$slideOrder		= $params->get('slide_order', 'alpha');
$slideWidth		= intval($params->get('slide_width'));
$slideHeight	= intval($params->get('slide_height'));
$slideJQuery	= intval($params->get('slide_jquery'));


// file-List
$aImgTypes = array(
	1,
	2,
	3
);
$aFiles = array();
if ($handle = opendir($slideFolder)) {
    while (false !== ($file = readdir($handle))) {
    	$img = getimagesize($slideFolder . '/' . $file);
        if (in_array($img[2], $aImgTypes)) {
            $aFiles[] = $file;
        }
    }
    closedir($handle);
}


// ordering of files
switch ($slideOrder) {
	case 'random':
		shuffle($aFiles);
		break;
		
	case 'alpha':
	default:
		sort($aFiles);
		break;
}


// after sorting we need the scaled image sizes
$aFileWidth = array();
$aFileHeight = array();
foreach ($aFiles as $f) {
	$img			= getimagesize($slideFolder . '/' . $f);
	$scale			= scaleImage($img[0], $img[1], $slideWidth, $slideHeight);
	$aFileWidth[]	= $scale['w'];
	$aFileHeight[]	= $scale['h'];
}


$slideStartImg			= $aFiles[0];
$slideNum				= count($aFiles);
$slideImgString			= "'" . JURI::base() . $slideFolder . "/" . implode("','" . JURI::base() . $slideFolder . "/", $aFiles) . "'";
$slideImgWidthString	= implode(",", $aFileWidth);
$slideImgHeightString	= implode(",", $aFileHeight);

require(JModuleHelper::getLayoutPath('mod_nsystem_slideshow'));